=== debian/changelog ===
openjdk-25 (25+36-1) unstable; urgency=medium

  * OpenJDK 25 GA, build 36. Release notes:
    https://mail.openjdk.org/pipermail/jdk-dev/2025-September/010483.html

  [ Vladimir Petko ]
  * d/rules: Mark as release.
  * d/watch: Regenerate.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Sep 2025 02:43:31 +0200
